#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <string.h>

const char g_aClassName[] = "PriorityControl_for_RagnarokOnline";

#define ID_TIMER 1
#define FILENAME "ropc_setting.txt"

volatile int g_timerCounter = 200;

LRESULT CALLBACK procedure(HWND hWindow, UINT message, WPARAM wParam, LPARAM lParam);
void setVariable();
void procedurePriorityControl();

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, LPSTR, int)
{
	WNDCLASS windowClass;
	MSG message;
	char *pFilename;
	const DWORD LENGTH = 0x10000;

	pFilename = new char[LENGTH];
	if (LENGTH != GetModuleFileName(NULL, pFilename, LENGTH))
	{
		*strrchr(pFilename, '\\') = '\0';
		SetCurrentDirectory(pFilename);
	}

	delete []pFilename;

	setVariable();

	ZeroMemory(&windowClass, sizeof WNDCLASS);
	windowClass.lpfnWndProc = procedure;
	windowClass.hInstance = hInstance;
	windowClass.lpszClassName = g_aClassName;
	RegisterClass(&windowClass);

	CreateWindow(g_aClassName, "", WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

	while (GetMessage(&message, NULL, 0, 0))
	{
		TranslateMessage(&message);
		DispatchMessage(&message);
	}

	return (message.wParam);
}

LRESULT CALLBACK procedure(HWND hWindow, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_TIMER:
		procedurePriorityControl();
		break;

	case WM_CREATE:
		SetTimer(hWindow, ID_TIMER, g_timerCounter, NULL);
		break;

	case WM_DESTROY:
		KillTimer(hWindow, ID_TIMER);
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWindow, message, wParam, lParam);
	}

	return 0;
}

void setVariable()
{
	FILE *pFile;


	pFile = fopen(FILENAME, "rt");
	if (!pFile)
		return;

	fscanf(pFile, "%d", &g_timerCounter);
	fclose(pFile);
}

void procedurePriorityControl()
{
	HWND hWindow;
	DWORD idProccess;
	HANDLE hProccess;


	hWindow = FindWindow("Ragnarok", "Ragnarok");
	if (!hWindow)
		return;

	if (!GetWindowThreadProcessId(hWindow, &idProccess))
		return;

	hProccess = OpenProcess(PROCESS_SET_INFORMATION, FALSE, idProccess);
	if (!hProccess)
		return;

	SetPriorityClass(hProccess, IDLE_PRIORITY_CLASS);
	CloseHandle(hProccess);
}
